/* Generated by wayland-scanner 1.22.0 */

#ifndef DDE_SHELL_CLIENT_PROTOCOL_H
#define DDE_SHELL_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client-core.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_dde_shell The dde_shell protocol
 * @section page_ifaces_dde_shell Interfaces
 * - @subpage page_iface_dde_surface_manager - get shell surface info
 * - @subpage page_iface_dde_shell_surface - dde shell surface
 * @section page_copyright_dde_shell Copyright
 * <pre>
 *
 * Copyright (C) 2020 ~ 2020 Deepin Technology Co., Ltd.
 *
 * Author:     zccrs <zccrs@live.com>
 * Maintainer: zccrs <zhangjide@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * </pre>
 */
struct dde_shell_surface;
struct dde_surface_manager;
struct wl_surface;

#ifndef DDE_SURFACE_MANAGER_INTERFACE
#define DDE_SURFACE_MANAGER_INTERFACE
/**
 * @page page_iface_dde_surface_manager dde_surface_manager
 * @section page_iface_dde_surface_manager_desc Description
 *
 * Eg: window position.
 * @section page_iface_dde_surface_manager_api API
 * See @ref iface_dde_surface_manager.
 */
/**
 * @defgroup iface_dde_surface_manager The dde_surface_manager interface
 *
 * Eg: window position.
 */
extern const struct wl_interface dde_surface_manager_interface;
#endif
#ifndef DDE_SHELL_SURFACE_INTERFACE
#define DDE_SHELL_SURFACE_INTERFACE
/**
 * @page page_iface_dde_shell_surface dde_shell_surface
 * @section page_iface_dde_shell_surface_desc Description
 *
 *
 * @section page_iface_dde_shell_surface_api API
 * See @ref iface_dde_shell_surface.
 */
/**
 * @defgroup iface_dde_shell_surface The dde_shell_surface interface
 *
 *
 */
extern const struct wl_interface dde_shell_surface_interface;
#endif

#define DDE_SURFACE_MANAGER_GET_SURFACE 0


/**
 * @ingroup iface_dde_surface_manager
 */
#define DDE_SURFACE_MANAGER_GET_SURFACE_SINCE_VERSION 1

/** @ingroup iface_dde_surface_manager */
static inline void
dde_surface_manager_set_user_data(struct dde_surface_manager *dde_surface_manager, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) dde_surface_manager, user_data);
}

/** @ingroup iface_dde_surface_manager */
static inline void *
dde_surface_manager_get_user_data(struct dde_surface_manager *dde_surface_manager)
{
	return wl_proxy_get_user_data((struct wl_proxy *) dde_surface_manager);
}

static inline uint32_t
dde_surface_manager_get_version(struct dde_surface_manager *dde_surface_manager)
{
	return wl_proxy_get_version((struct wl_proxy *) dde_surface_manager);
}

/** @ingroup iface_dde_surface_manager */
static inline void
dde_surface_manager_destroy(struct dde_surface_manager *dde_surface_manager)
{
	wl_proxy_destroy((struct wl_proxy *) dde_surface_manager);
}

/**
 * @ingroup iface_dde_surface_manager
 *
 * the dde surface contains window geometry interface.
 */
static inline struct dde_shell_surface *
dde_surface_manager_get_surface(struct dde_surface_manager *dde_surface_manager, struct wl_surface *surface)
{
	struct wl_proxy *id;

	id = wl_proxy_marshal_flags((struct wl_proxy *) dde_surface_manager,
			 DDE_SURFACE_MANAGER_GET_SURFACE, &dde_shell_surface_interface, wl_proxy_get_version((struct wl_proxy *) dde_surface_manager), 0, NULL, surface);

	return (struct dde_shell_surface *) id;
}

/**
 * @ingroup iface_dde_shell_surface
 * @struct dde_shell_surface_listener
 */
struct dde_shell_surface_listener {
	/**
	 * notify geometry changed
	 *
	 * Send event on the window geometry changed
	 * @param x x pos
	 * @param y y pos
	 * @param w width
	 * @param h height
	 */
	void (*geometry)(void *data,
			 struct dde_shell_surface *dde_shell_surface,
			 int32_t x,
			 int32_t y,
			 int32_t w,
			 int32_t h);
	/**
	 * notify property changed
	 *
	 * Send event on the window property changed
	 * @param name property name
	 * @param value property value
	 */
	void (*property)(void *data,
			 struct dde_shell_surface *dde_shell_surface,
			 const char *name,
			 struct wl_array *value);
};

/**
 * @ingroup iface_dde_shell_surface
 */
static inline int
dde_shell_surface_add_listener(struct dde_shell_surface *dde_shell_surface,
			       const struct dde_shell_surface_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) dde_shell_surface,
				     (void (**)(void)) listener, data);
}

#define DDE_SHELL_SURFACE_GET_GEOMETRY 0
#define DDE_SHELL_SURFACE_SET_PROPERTY 1
#define DDE_SHELL_SURFACE_GET_PROPERTY 2

/**
 * @ingroup iface_dde_shell_surface
 */
#define DDE_SHELL_SURFACE_GEOMETRY_SINCE_VERSION 1
/**
 * @ingroup iface_dde_shell_surface
 */
#define DDE_SHELL_SURFACE_PROPERTY_SINCE_VERSION 1

/**
 * @ingroup iface_dde_shell_surface
 */
#define DDE_SHELL_SURFACE_GET_GEOMETRY_SINCE_VERSION 1
/**
 * @ingroup iface_dde_shell_surface
 */
#define DDE_SHELL_SURFACE_SET_PROPERTY_SINCE_VERSION 1
/**
 * @ingroup iface_dde_shell_surface
 */
#define DDE_SHELL_SURFACE_GET_PROPERTY_SINCE_VERSION 1

/** @ingroup iface_dde_shell_surface */
static inline void
dde_shell_surface_set_user_data(struct dde_shell_surface *dde_shell_surface, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) dde_shell_surface, user_data);
}

/** @ingroup iface_dde_shell_surface */
static inline void *
dde_shell_surface_get_user_data(struct dde_shell_surface *dde_shell_surface)
{
	return wl_proxy_get_user_data((struct wl_proxy *) dde_shell_surface);
}

static inline uint32_t
dde_shell_surface_get_version(struct dde_shell_surface *dde_shell_surface)
{
	return wl_proxy_get_version((struct wl_proxy *) dde_shell_surface);
}

/** @ingroup iface_dde_shell_surface */
static inline void
dde_shell_surface_destroy(struct dde_shell_surface *dde_shell_surface)
{
	wl_proxy_destroy((struct wl_proxy *) dde_shell_surface);
}

/**
 * @ingroup iface_dde_shell_surface
 *
 * reques windo geometry, will notify by "geometry" event.
 */
static inline void
dde_shell_surface_get_geometry(struct dde_shell_surface *dde_shell_surface)
{
	wl_proxy_marshal_flags((struct wl_proxy *) dde_shell_surface,
			 DDE_SHELL_SURFACE_GET_GEOMETRY, NULL, wl_proxy_get_version((struct wl_proxy *) dde_shell_surface), 0);
}

/**
 * @ingroup iface_dde_shell_surface
 *
 * the property value is json format string.
 */
static inline void
dde_shell_surface_set_property(struct dde_shell_surface *dde_shell_surface, const char *name, struct wl_array *value)
{
	wl_proxy_marshal_flags((struct wl_proxy *) dde_shell_surface,
			 DDE_SHELL_SURFACE_SET_PROPERTY, NULL, wl_proxy_get_version((struct wl_proxy *) dde_shell_surface), 0, name, value);
}

/**
 * @ingroup iface_dde_shell_surface
 *
 * the property value is json format string.
 */
static inline void
dde_shell_surface_get_property(struct dde_shell_surface *dde_shell_surface, const char *name)
{
	wl_proxy_marshal_flags((struct wl_proxy *) dde_shell_surface,
			 DDE_SHELL_SURFACE_GET_PROPERTY, NULL, wl_proxy_get_version((struct wl_proxy *) dde_shell_surface), 0, name);
}

#ifdef  __cplusplus
}
#endif

#endif
